import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { Comment, CommentParam } from './model';
import { OPEN_API_URL } from '@/config/setting';

/**
 * 分页查询商品评价
 */
export async function pageComments(params: CommentParam) {
  const res = await request.get<ApiResult<PageResult<Comment>>>(
    OPEN_API_URL + '/shop/comment/page',
    { params }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询商品评价列表
 */
export async function listComments(params?: CommentParam) {
  const res = await request.get<ApiResult<Comment[]>>(
    OPEN_API_URL + '/shop/comment',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加商品评价
 */
export async function addComment(data: Comment) {
  const res = await request.post<ApiResult<unknown>>(
    OPEN_API_URL + '/shop/comment',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改商品评价
 */
export async function updateComment(data: Comment) {
  const res = await request.put<ApiResult<unknown>>(
    OPEN_API_URL + '/shop/comment',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除商品评价
 */
export async function removeComment(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    OPEN_API_URL + '/shop/comment/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除商品评价
 */
export async function removeComments(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    OPEN_API_URL + '/shop/comment/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}
